﻿Function Get-RegistryData {

Param(
    [Parameter(
    Mandatory=$true)]
    [string]$RegistryPath #enter the full registry path including the Root key, eg HKEY_LOCAL_MACHINE


)

    $Registrykeys = Get-Item -Path "Registry::$RegistryPath" 

    $Registrykeys | Select-Object -ExpandProperty Property | 

    ForEach-Object {
        $name = $_
        $data = "" | Select-Object -Property Name, Path, Type, Data #creates an empty 
        $data.Name = $name
        $data.Type = $Registrykeys.GetValueKind($name)
        $data.Data = $Registrykeys.GetValue($name)
        $data.Path = "Registry::$Registrykeys"
        $data
  
    }
}

